VTK: vtkResourceStream Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkResourceStream Class Referenceabstract

Abstract class used for custom streams. More...

`#include <vtkResourceStream.h>`

Inheritance diagram for vtkResourceStream:
[legend]
Collaboration diagram for vtkResourceStream:
[legend]

## Public Types
enum class | SeekDirection { Begin = 0 , Current = 1 , End = 2 }
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkResourceStream * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual std::size_t | Read (void *buffer, std::size_t bytes)=0
| Read data form the stream. More...
virtual bool | EndOfStream ()=0
| Check if the stream reached an end. More...
virtual vtkTypeInt64 | Seek (vtkTypeInt64 pos, SeekDirection dir)
| Move the stream cursor position. More...
virtual vtkTypeInt64 | Tell ()
| Get the stream cursor position. More...
bool | SupportSeek () const
| Check if stream supports Seek and Tell functions. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkResourceStream * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkResourceStream (bool supportSeek)
| Constructor. More...
| ~vtkResourceStream () override
| vtkResourceStream (const vtkResourceStream &)=delete
vtkResourceStream & | operator= (const vtkResourceStream &)=delete
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Abstract class used for custom streams.

vtkResourceStream provides a high-level interface for manipulating custom streams. This class is designed to be used instead of "SetFileName" and "SetInputString" or similar that exists in most of reader or reader-like classes in VTK.

vtkResourceStream only support unformatted input, user must use external solution to format the input, such as sscanf or scnlib, fast_float or strtoX

vtkResourceStream may be support seeking, code that uses vtkResourceStream should take in account this, and support for both seekable stream and not seekable streams, if possible. `stream.SupportSeek()` can be used for support checking.

Definition at line 30 of file vtkResourceStream.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkResourceStream::Superclass

Definition at line 42 of file vtkResourceStream.h.

## Member Enumeration Documentation

## ◆ SeekDirection

enum vtkResourceStream::SeekDirection
| strong

Enumerator
Begin |
Current |
End |

Definition at line 35 of file vtkResourceStream.h.

## Constructor & Destructor Documentation

## ◆ vtkResourceStream() [1/2]

vtkResourceStream::vtkResourceStream | ( | bool | supportSeek | ) |
| protected

Constructor.

Only constructor, subclasses must fill the vtkResourceStreamInfo and pass it to this constructor.

Parameters

  supportSeek | true is Seek and Tell are supported

## ◆ ~vtkResourceStream()

vtkResourceStream::~vtkResourceStream | ( |  | ) |
| overrideprotected

## ◆ vtkResourceStream() [2/2]

vtkResourceStream::vtkResourceStream | ( | const vtkResourceStream & |  | ) |
| protecteddelete

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkResourceStream::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkResourceStream::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkMemoryResourceStream, and vtkFileResourceStream.

## ◆ SafeDownCast()

static vtkResourceStream* vtkResourceStream::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkResourceStream::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkMemoryResourceStream, and vtkFileResourceStream.

## ◆ NewInstance()

vtkResourceStream* vtkResourceStream::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkResourceStream::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ Read()

virtual std::size_t vtkResourceStream::Read | ( | void * | buffer,
|  | std::size_t | bytes
| ) |  |
| pure virtual

Read data form the stream.

Read at most `bytes` bytes from input stream. If this function reads less that `bytes` bytes, then EndOfStream must return true.

Parameters

  buffer | User provided storage buffer, may be nullptr if bytes == 0
  bytes | Maximum amount of bytes to read.

Returns
  The number of bytes read, may be 0.

Implemented in vtkMemoryResourceStream, and vtkFileResourceStream.

## ◆ EndOfStream()

virtual bool vtkResourceStream::EndOfStream | ( |  | ) |
| pure virtual

Check if the stream reached an end.

The stream may be out of range (EOF) if a Seek call move before stream begin (0), or after stream end (max) Seek on an EndOfStream stream may restore it back to a valid state. Read on an invalid stream must do nothing and return 0.

Returns
  Return true if the stream reached the end of input, false otherwise.

Implemented in vtkMemoryResourceStream, and vtkFileResourceStream.

## ◆ Seek()

virtual vtkTypeInt64 vtkResourceStream::Seek | ( | vtkTypeInt64 | pos,
|  | SeekDirection | dir
| ) |  |
| virtual

Move the stream cursor position.

Base version does nothing and returns 0. This function does not check if the position is out of range. EndOfFile() result must only change after a call of Read with non-zero size.

Returns
  Current position in stream.

Reimplemented in vtkMemoryResourceStream, and vtkFileResourceStream.

## ◆ Tell()

virtual vtkTypeInt64 vtkResourceStream::Tell | ( |  | ) |
| virtual

Get the stream cursor position.

Base version calls `Seek(0, std::ios_base::cur)`. If seeking is unsupported, return 0. Subclasses may reimplement it to provide a more efficient version.

Returns
  Current position in stream.

Reimplemented in vtkMemoryResourceStream, and vtkFileResourceStream.

## ◆ SupportSeek()

bool vtkResourceStream::SupportSeek | ( |  | ) | const

Check if stream supports Seek and Tell functions.

Returns
  true if Seek and Tell functions are supported.

## ◆ operator=()

vtkResourceStream& vtkResourceStream::operator= | ( | const vtkResourceStream & |  | ) |
| protecteddelete

The documentation for this class was generated from the following file:

- IO/Core/vtkResourceStream.h